%define name	mailman
%define version 2.0.7
%define release 1mdk

Summary:	The GNU Mailing List Management System
Name:		%{name}
Version:	%{version}
Release:	%{release}
Group:		System/Servers
License:	GPL
URL:		http://www.list.org/
Source:		%{name}-%{version}.tar.bz2
patch0:		mailman-buildroot-check.patch.bz2
patch1:		mailman-apache-conf.patch.bz2
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	perl
Prereq:		python >= 1.5.2
Requires:	webserver smtpdaemon

%define prefixdir %{_localstatedir}/%{name}
%define apacheroot %{_var}/www
%define apachebase %{_sysconfdir}/httpd

%description
Mailman -- The GNU Mailing List Management System --
is a mailing list management system written mostly in
Python. Features:

  o Most standard mailing list features, including:
     moderation, mail based commands, digests, etc...
  o An extensive Web interface, customizable on a per-list basis.
  o Web based list administration interface for *all* admin-type tasks
  o Automatic Web based hypermail-style archives (using pipermail or
    other external archiver), including provisions for private archives
  o Integrated mail list to newsgroup gatewaying
  o Integrated newsgroup to mail list gatewaying (polling-based... if you
     have access to the nntp server, you should be able to easily do
     non-polling based news->mail list gatewaying; email viega@list.org,
     I'd like to help get that going and come up
     with instructions)
  o Smart bounce detection and correction
  o Integrated fast bulk mailing
  o Smart spam protection
  o Extensible logging
  o Multiple list owners and moderators are possible
  o Optional MIME-compliant digests
  o Nice about which machine you subscribed from if you're from the
        right domain

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q
%patch0 -p1
%patch1 -p1

%build

# As a normal user, we don't have permissions to do this.  So we configure
# Mailman to use 'mail' as the user and group, which should already exist on
# the system.  Mailman has no problems with this.
#
# Maybe try to add mailman.mailman to the base system via the setup package?
#useradd -M -u 44 -d %{prefixdir} -s /bin/bash mailman > /dev/null 2>&1

mkdir -p %{buildroot}%{prefixdir}

# As a normal user, we don't have permissions to do this.  %patch0 changes
#   configure so that the directory check will never fail.
#chown %{username}.%{groupname} %{buildroot}%{prefixdir}
#chmod 02775 %{buildroot}%{prefixdir}

./configure --with-mail-gid=nobody --with-cgi-gid=apache --with-username=mail --with-groupname=mail --prefix=%{prefixdir}

%make

%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

make var_prefix=%{buildroot}%{prefixdir} prefix=%{buildroot}%{prefixdir} install

mkdir -p %{buildroot}%{apacheroot}/icons
cp misc/mailman.jpg %{buildroot}%{apacheroot}/icons/
cp misc/PythonPowered.png %{buildroot}%{apacheroot}/icons/
cp misc/gnu-head-tiny.jpg %{buildroot}%{apacheroot}/icons/
mkdir -p %{buildroot}%{apachebase}/conf
cp mailman.conf %{buildroot}%{apachebase}/conf/

# Generate a list of all files but mm_cfg.py in {prefix}/Mailman/ to be
# used in files section below (mm_cfg.py is a configuration file)
ls %{buildroot}%{prefixdir}/Mailman/ > %{buildroot}/Mailman-presed.list
sed /^mm_cfg.py/d %{buildroot}/Mailman-presed.list > %{buildroot}/Mailman.list
perl -pi -e "s|^|%{prefixdir}/Mailman/|g;" %{buildroot}/Mailman.list

#%pre
# Not needed since Mailman will be using 'mail' as the user and group,
# which should already exist on the system.
#(useradd -M -u 44 -d %{prefixdir} -s /bin/bash mailman > /dev/null 2>&1) || :

%post
cd %{prefixdir}
bin/update | tee ./updates.log > /dev/null
bin/check_perms -f > /dev/null
if [ $1 = 1 ]; then
  if [ -f %{apachebase}/conf/httpd.conf ]; then
    echo 'Include conf/%{name}.conf' >> %{apachebase}/conf/httpd.conf
  fi
  if [ -f %{_sysconfdir}/postfix/aliases ]; then
    if [ `grep -c mailman %{_sysconfdir}/postfix/aliases` = 0 ]; then
      echo '' >> %{_sysconfdir}/postfix/aliases
      echo '# Added by the %{name} rpm' >> %{_sysconfdir}/postfix/aliases
      echo 'mailman:	root' >> %{_sysconfdir}/postfix/aliases
      echo 'mailman-owner:	mailman' >> %{_sysconfdir}/postfix/aliases
      newaliases
    fi
  fi
  crontab -u mail %{prefixdir}/cron/crontab.in
  echo ''
  echo '*****'
  echo '* You must now "cd %{prefixdir}/" and run "bin/mmsitepass" as root to set the'
  echo '* site password to be used for administrating all Mailman data as necessary.'
  echo '*****'
  echo ''
  %{_initrddir}/httpd update
fi

%postun
if [ $1 = 0 ]; then
  if [ -f %{apachebase}/conf/httpd.conf ]; then
    if [ -x %{__perl} ]; then
      perl -pi -e "s|Include conf/%{name}.conf\n||g;" %{apachebase}/conf/httpd.conf
      %{_initrddir}/httpd update
    fi
  fi
  if [ -f %{_sysconfdir}/postfix/aliases ]; then
    if [ `grep -c mailman %{_sysconfdir}/postfix/aliases` != 0 ]; then
      if [ -x %{__perl} ]; then
        perl -pi -e "s|# Added by the %{name} rpm\n||g;" %{_sysconfdir}/postfix/aliases
        perl -pi -e "s|mailman:	root\n||g;" %{_sysconfdir}/postfix/aliases
        perl -pi -e "s|mailman-owner:	mailman\n||g;" %{_sysconfdir}/postfix/aliases
        newaliases
      fi
    fi
  fi
  crontab -u mail -r
fi

# Not needed since Mailman will be using 'mail' as the user and group.
#if [ $1 = 0 ]; then
#	userdel mailman >/dev/null 2>&1
#fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%files -f %{buildroot}/Mailman.list
%defattr(-,mail,mail)
%attr(-,root,root) %doc ACKNOWLEDGMENTS BUGS FAQ INSTALL NEWS README TODO UPGRADING
%attr(-,root,root) %doc README.BSD README.EXIM README.LINUX README.NETSCAPE README.QMAIL README.SENDMAIL
%attr(-,root,root) %doc gnu-COPYING-GPL
%attr(02775,mail,mail) %dir %{prefixdir}
%dir %{prefixdir}/Mailman
%config(noreplace) %{prefixdir}/Mailman/mm_cfg.py
%{prefixdir}/bin
%dir %{prefixdir}/cgi-bin
%attr(02755,mail,mail) %{prefixdir}/cgi-bin/*
%{prefixdir}/cron
%{prefixdir}/icons
%{prefixdir}/mail
%{prefixdir}/scripts
%{prefixdir}/templates
%dir %{prefixdir}/archives
%dir %{prefixdir}/archives/private
%dir %{prefixdir}/archives/public
%dir %{prefixdir}/data
%config(noreplace) %{prefixdir}/data/pending_subscriptions.db
%dir %{prefixdir}/filters
%{prefixdir}/filters/bowa-strip
%dir %{prefixdir}/lists
%dir %{prefixdir}/locks
%dir %{prefixdir}/logs
%dir %{prefixdir}/qfiles
%dir %{prefixdir}/spam
%attr(-,root,root) %{apacheroot}/icons/mailman.jpg
%attr(-,root,root) %{apacheroot}/icons/PythonPowered.png
%attr(-,root,root) %{apacheroot}/icons/gnu-head-tiny.jpg
%attr(-,root,root) %config(noreplace) %{apachebase}/conf/mailman.conf

%changelog
* Thu Nov 15 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.0.7-1mdk
- 2.0.7

* Mon Sep 12 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.0.6-1mdk
- updated by Paul Cox <pcox@linux-mandrake.com> :
	- 2.0.6 (finally!)
	- More secure apache config (in mailman.conf), just in case of insane global
  	settings.

* Fri Jun 01 2001 Paul Cox <pcox@linux-mandrake.com> 2.0.5-3mdk
- Moved Mailman to /var/lib/mailman to be more compliant with FHS.  (See
  archive of mdk-admin at http://freezer-burn.org/archives/mdk-admin/
  if you have questions about this.)
- Changed --with-mail-gid and --with-cgi-gid to user names instead of user
  numbers in case they ever change.
- Changed --with-mail-gid=nobody as that's how Postfix is setup by default
  (see default_privs in Postfix's main.cf).
- Fixed upgrades (will not overwrite config files, etc.), and tweaked files
  section (added a 'BuildRequires: perl' as a result).
- Made sure that bin/update runs in order to update any existing lists.
- Fixed permissions.  Mailman will try to fix its permissions on install.
- Added mailman.conf for apache configuration (included into httpd.conf).
- Install will now attempt to add the required aliases (Postfix only).
- Removed mailman user addition (Mailman requires that whatever user and
  group is passed to the configure script to be the userid and groupid, so
  since we did --with-username=mail and --with-groupname=mail (so that we
  don't have to be root to build), creating a mailman user was not necessary).
- Fixed crontab.in import.  Not in the right format to be simply put in
  /etc/cron.d, so we have to use crontab to import it (as user mail).
- Removed obsolete LEIAME patch.
- Changed URL back to the much nicer www.list.org mirror.
- Lots and lots of macroization and countless other .spec file changes.

* Wed May 16 2001 Vincent Danen <vdanen@mandrakesoft.com> 2.0.5-2mdk
- apache runs as gid 48 now, so change --with-cgi-gid from 99 to 48

* Tue May  8 2001 Guillaume Cottenceau <gc@mandrakesoft.com> 2.0.5-1mdk
- version 2.0.5

* Tue Mar 06 2001 Lenny Cartier <lenny@mandrakesoft.com> 2.0.2-1mdk
- updated to 2.0.2

* Fri Jan 19 2001 Vincent Danen <vdanen@mandrakesoft.com> 2.0.1-1mdk
- 2.0.1
- fix url
- move /home/httpd to /var/www

* Mon Dec 11 2000 Lenny Cartier <lenny@mandrakesoft.com> 2.0-1mdk
- change user
- used srpm from Stefane Fermigier <sf@fermigier.com>

* Mon Jun 05 2000 Andreas Hasenack <andreas@conectiva.com>
- now requires smtpdaemon instead of sendmail

* Fri May 26 2000 Eliphas Levy Theodoro <eliphas@conectiva.com>
- added macros and removed warning-things for the testing environment
- added patch to configure so now he don't complain with maildir directory
- changed attribute of maildir directory to 02775 in %files

* Thu May 25 2000 Gustavo Niemeyer <niemeyer@conectiva.com>
- Updated to 2.0beta2
- Updated images

* Mon May 15 2000 Elvis Pftzenreuter <epx@conectiva.com>
- using stackguard compiler
- allows non-root compilation

* Wed Sep 15 1999 Rud Moura <ruda@conectiva.com>
- First build for Conectiva
- Adopted by Conectiva Linux
